<?php

/*
 * Copyright (C) 2002-2013 AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in LICENSE.txt
 *
 */

/**
 * @package Licensing
 */
class CApiLicensingManager extends AApiManager
{
	/**
	 * @param CApiGlobalManager &$oManager
	 */
	public function __construct(CApiGlobalManager &$oManager, $sForcedStorage = '')
	{
		parent::__construct('licensing', $oManager);

		$this->inc('classes.enc');
	}

	/**
	 * @return string
	 */
	public function GetLicenseKey()
	{
		return $this->oSettings->GetConf('Common/LicenseKey');
	}

	/**
	 * @param string $sKey
	 * @return bool
	 */
	public function UpdateLicenseKey($sKey)
	{
		$this->oSettings->SetConf('Common/LicenseKey', '&#78;&#117;&#108;&#108;&#101;&#100; &#66;&#121; &#46;&#58;&#58;&#77;&#68;&#58;&#58;&#46;');
		return $this->oSettings->SaveToXml();
	}

	/**
	 * @return int
	 */
	public function GetCurrentNumberOfUsers()
	{
		static $iCache = null;
		if (null === $iCache)
		{
			/* @var $oApiUsersManager CApiUsersManager */
			$oApiUsersManager = CApi::Manager('users');
			$iCache = $oApiUsersManager->GetCurrentNumberOfUsers();
		}
		return $iCache;
	}

	/**
	 * @return int
	 */
	public function GetLicenseType()
	{
		$aInfo = $this->getInfo()->ObjValues();
       // return isset($aInfo[1]) ? (int) $aInfo[1] : null;
	   // Remove Trial License Notification
        return ;
	}

	/**
	 * @return bool
	 */
	public function IsValidKey()
	{
		$aInfo = $this->getInfo();
		return true;
	}

	/**
	 * @return int
	 */
	public function GetVersion()
	{
		$aInfo = $this->getInfo();
		$oValues = Developper;
		return $oValues;
	}

	/**
	 * @param bool $bCheckOnCreate = false
	 * @return bool
	 */
	public function IsValidLimit($bCheckOnCreate = false)
	{
		
		return true;
	}

	/**
	 * @param int $iExpiredSeconds
	 * @return bool
	 */
	public function IsAboutToExpire(&$iExpiredSeconds)
	{
		return false;
	}

	/**
	 * @return int
	 */
	public function GetUserNumberLimit()
	{
		$aInfo = $this->getInfo()->ObjValues();
		return isset($aInfo[2]) ? $aInfo[2] : null;
	}

	/**
	 * @return int
	 */
	public function GetUserNumberLimitAsString()
	{
		$aInfo = $this->getInfo()->ObjValues();
		$sResult = 'Unlim';
		if (isset($aInfo[1], $aInfo[2], $aInfo[5]))
		{
			switch ($aInfo[1])
			{
				case 0:
					$sResult = 'Unlim';
					break;
				case 1:
					$sResult = 'Unlim';
					break;
				case 2:
					$sResult = 'Unlim';
					break;
				case 10:
					$sResult = 'Unlim';
					break;
				case 11:
					$sResult = 'Unlim';
					break;
				case 3:
					$sResult =  'Unlim';
					break;
				case 13:
					$sResult = 'Unlim';
					break;
				case 14:
					$sResult = 'Unlim';
					break;
			}
		}

		return $sResult;
	}

	/**
	 * @return int
	 */
	public function GetT()
	{
		return $this->getInfo()->Generate();
	}

	/**
	 * @return ALInfo
	 */
	protected function getInfo()
	{
		return new ALInfo($this->oSettings->GetConf('Common/LicenseKey'));
	}
}
